/*
 *
 *   (c) Copyright International Business Machines Corporation 2001. 
 *                        All Rights Reserved. 
 *
 *  Description
 *
 *    z/VM 4.2 vmadmin client program for java
 *
 *  Usage
 *
 *   java vmadmin  server_ip_address   operands    
 *
 *  Restriction
 *   The following commands are not supported.
 *     server import, export, collect, error
 *
 *  Change History
 *    1.00  11/30/2001   Initial     
 *
 *  Author: Kazuo Iimura (iimura@jp.ibm.com)
 *
 */
import java.io.*;
import java.net.*;
/*
 *  vmadmin client program
 */

public class vmadmin {

    public static int server_port = 9998;
    public static String host_cp= "Cp037";
    public static String cmd="";
    public static String server_ip;
    public static Socket clientSocket;
    public static OutputStreamWriter  outbound;
    public static InputStreamReader inbound;
    public static int default_timeout = 20 * 1000;   // default socket timeout in milliseconds
	public static int timeout=0;

    public static void main(String args[])
    {
		if (args.length < 2) {
			System.err.println("Usage:  vmadmin <server IP address> <vmadmin command>");
			System.exit(1);
		}
		String a1 = new String(args[1]);
		String a11 = a1.toUpperCase();

		if (a11.startsWith("SERV")) {
			String a2 = new String(args[2]);
			String a21 = a2.toUpperCase();
			if ( a21.startsWith("ERR") ||
				 a21.startsWith("EXP") ||
				 a21.startsWith("COLL") ||
				 a21.startsWith("IMP") ) {
				System.err.println(" Sorry... not supported command ");
				System.err.println(" Use client in CMS or Linux/390 ");
				System.exit(1);
			}
		}
		server_ip=args[0];
		for ( int i=1; i < args.length; i++ ) {
			cmd=cmd + args[i] + " "; 
		}
		try {
			cmdProc();
		} catch (Exception e) {
			System.err.println("Exception: " + e);
			System.exit(1) ;
		}
	}     // end of main

    public static void cmdProc() 
	{

		try {
			BufferedWriter bwout=null;
			BufferedReader keyin = new BufferedReader( new InputStreamReader(System.in) );
			clientSocket = new Socket(server_ip, server_port );
			outbound = new OutputStreamWriter( clientSocket.getOutputStream(),
												host_cp );
			bwout= new BufferedWriter(outbound);
			inbound = new InputStreamReader(clientSocket.getInputStream(), host_cp );
			timeout=default_timeout;
			clientSocket.setSoTimeout( timeout );
			bwout.write( cmd );      // send vmadmin command 
			bwout.flush();
			byte tt;
			char header[] = new char[9];
			inbound.read(header, 0, 9);
			char cc;
			cc=header[0];
			while ( cc != 'E'  ) {
				String header_s = new String( header );
				String d_len=header_s.substring(1,9);
				String t_out="";
				int len = Integer.parseInt( d_len );
				// write message 
				if ( cc!= 'U' ) {
					char txt[] = new char[len];
					 inbound.read(txt, 0, len);
					if ( cc!='W') {
						System.out.println( txt );
					}
					t_out=new String(txt);
				}

				// set timeout
				int new_timeout;
				switch ( cc ) {
					case 'C':
						new_timeout = 0;   // set infinite time
						break;
					case 'W':
						new_timeout = Integer.parseInt( t_out )*1000;
				    	break;
					default:
						new_timeout = default_timeout;   // set default time out 
				    	break;
				} 

				// send data again
				switch ( cc ) {
					case 'C': 
					case 'S':
						String s_in=keyin.readLine();
						bwout.write( s_in );
						bwout.flush();
						break;
					case 'U':
					case 'W':
					case 'R':
						break;
					default:
				}
				while ( true ) {
					try {
						clientSocket.setSoTimeout( new_timeout );
						inbound.read(header, 0, 9);
						break;
					} catch (InterruptedIOException e) {
						System.out.println("Command is still processing; Please wait..... ");
						new_timeout=default_timeout;
					}
				}
				cc=header[0];
			}
			System.out.println("Command Complete" );
			bwout.close();
			inbound.close();
			clientSocket.close();
		} catch (Exception e) {
			System.out.println("Exception: " + e);
			System.exit(1) ;
		}
	}  // end of cmdProc
} // end of class vmadmin
